﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.XR.iOS;

public class BlendshapePrinter : MonoBehaviour {

	bool shapeEnabled = false;
	Dictionary<string, float> currentBlendShapes;
	int timesBlinked;
	bool wereEyesClosed;

	// Use this for initialization
	void Start () {
		UnityARSessionNativeInterface.ARFaceAnchorAddedEvent += FaceAdded;
		UnityARSessionNativeInterface.ARFaceAnchorUpdatedEvent += FaceUpdated;
		UnityARSessionNativeInterface.ARFaceAnchorRemovedEvent += FaceRemoved;
		timesBlinked = 0;
		wereEyesClosed = false;
	}

	void OnGUI()
	{
		if (shapeEnabled) {

		
			string blendshapes = "";
			string shapeNames = "";
			string valueNames = "";

/*			foreach(KeyValuePair<string,float> kvp in currentBlendShapes) {
				if (kvp.Value > 0.5) {
					blendshapes += " [";
					blendshapes += kvp.Key.ToString ();
					blendshapes += ":";
					blendshapes += kvp.Value.ToString ();
					blendshapes += "]\n";
				}
				shapeNames += "\"";
				shapeNames += kvp.Key.ToString ();
				shapeNames += "\",\n";
				valueNames += kvp.Value.ToString ();
				valueNames += "\n";
			}*/
		
			int jaw = (int)(currentBlendShapes ["jawOpen"]*10);
			int brow = (int)(currentBlendShapes ["browInnerUp"]*10);
			int left_eye = (int)(currentBlendShapes ["eyeBlink_L"]*10);
			int right_eye = (int)(currentBlendShapes ["eyeBlink_R"]*10);
			int mouth_right = (int)(currentBlendShapes ["mouthRight"]*10);
			int mouth_left = (int)(currentBlendShapes ["mouthLeft"]*10);



	
			if (!wereEyesClosed && left_eye > 6 && right_eye > 6) {
				timesBlinked++;
				wereEyesClosed = true;
			} else if (left_eye < 7 && right_eye < 7){
				wereEyesClosed = false;
			}
			blendshapes += "\n"; 
			blendshapes += "\n"; 
			blendshapes += "\n"; 

			blendshapes += "Times Blinked : [";
			blendshapes += timesBlinked;
			blendshapes += "]\n"; 
			blendshapes += "\n"; 


			blendshapes += "Mouth : [";
			if (mouth_right > 1) {
				blendshapes += "Left: "; 
				blendshapes += mouth_right;
			} else if (mouth_left > 1) {
				blendshapes += "Right: "; 
				blendshapes += mouth_left;
			} else {
				blendshapes += "CENTER";
			}

			blendshapes += "]\n"; 
			blendshapes += "\n"; 

			blendshapes += "Jaw Open : [";
			blendshapes += jaw;
			blendshapes += "]\n"; 
			blendshapes += "\n"; 

			blendshapes += "Brow up: [";
			blendshapes += brow;
			blendshapes += "]\n"; 
			blendshapes += "\n"; 

			blendshapes += "Left eye: [";
			blendshapes += left_eye;
			blendshapes += "]\n"; 
			blendshapes += "\n"; 

			blendshapes += "Right eye: [";
			blendshapes += right_eye;
			blendshapes += "]\n"; 
			blendshapes += "\n"; 


	//		GUI.skin.box.fontSize = 30;
	//		GUILayout.BeginHorizontal (GUILayout.ExpandHeight(true));
	//		GUILayout.Box (blendshapes);
	//		GUILayout.Box (info);
	//		GUILayout.EndHorizontal ();

	//		Debug.Log (shapeNames);
	//		Debug.Log (valueNames);

		}


	}

	void FaceAdded (ARFaceAnchor anchorData)
	{
		shapeEnabled = true;
		currentBlendShapes = anchorData.blendShapes;
	}

	void FaceUpdated (ARFaceAnchor anchorData)
	{
		currentBlendShapes = anchorData.blendShapes;
	}

	void FaceRemoved (ARFaceAnchor anchorData)
	{
		shapeEnabled = false;
	}

	
	// Update is called once per frame
	void Update () {
		
	}


}
