﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;
using UnityEngine.SceneManagement;


public class CollisionScript : MonoBehaviour {

	private int timesConverted;
	private int timesSpawned;
	private float gameTime;
	private float startTime;
	private int finalscore;
	public int percent;
	public Spawner spawn;

	void Start () {
		timesConverted = 0;
		finalscore = -1;
		percent = 0;
		startTime = Time.time;
		gameTime = Time.time+60.0f;
	}

	void OnParticleCollision(GameObject other) {
		

		try
		{
			// code that may raise exceptions
			Debug.Log ("COLLISION!!\n");
			Debug.Log (other);
			ColorStrobe strobe = other.GetComponent<ColorStrobe> ();
			if(!strobe.colorStrobe){
				strobe.colorStrobe = true;
				timesConverted++;
			}

			percent = (int)(((float)timesConverted / (float)timesSpawned)  * 100.0f);
		//	Debug.Log ("Spawned: "+timesSpawned+"\n");
		//	Debug.Log ("Converted: "+timesConverted+"\n");
		//	Debug.Log ("Percent: "+percent+"\n");
		//	Debug.Log ("COLLISION END!!\n");

		}
		catch(Exception ex)
		{
			// handle exception
		}
		finally
		{
			// final cleanup code
		}
	}

	void OnGUI() {
		String info = "\n\nTime: "+((int)(gameTime - Time.time))+"\n"+"Converted: "+timesConverted+ " / "+timesSpawned;
		percent = (int)(((float)timesConverted / (float)timesSpawned)  * 100.0f);
		if((gameTime - Time.time)<1){
			gameTime = 0;

			if (finalscore == -1) {
				finalscore = percent;
			}
			//SceneManager.LoadScene( SceneManager.GetActiveScene().buildIndex ) ;
			//Application.LoadLevel(Application.loadedLevel);
			info = "\n\nFINAL SCORE: "+finalscore+ "% ";
		}

		timesSpawned = spawn.amountSpawned;

//		String info = "\n\nConverted: "+percent+ "%";

		GUI.skin.box.fontSize = 70;
		GUI.contentColor=Color.green;	

		GUILayout.BeginHorizontal (GUILayout.ExpandHeight(true));
		GUILayout.Box (info);
		GUILayout.EndHorizontal ();

	
	}
}