﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.XR.iOS;

public class PlayerControlled : MonoBehaviour {

	bool shapeEnabled = false;
	public Camera theCamera;
	Dictionary<string, float> currentBlendShapes;
	public float moveSpeed = 10;
	public int rotateSpeed = 10;
	private Vector3 moveDirection;
//	public KeyCode moveForward = KeyCode.UpArrow;
//	public KeyCode moveBack = KeyCode.DownArrow;
//	public KeyCode moveLeft = KeyCode.LeftArrow;
//	public KeyCode moveRight = KeyCode.RightArrow;
	public KeyCode turnLeft = KeyCode.LeftArrow;
	public KeyCode turnRight = KeyCode.RightArrow;
	public KeyCode moveUp;
	public KeyCode moveDown;

	void Start () { // Called once when the script component is first enabled. Used for component initialization.
		UnityARSessionNativeInterface.ARFaceAnchorAddedEvent += FaceAdded;
		UnityARSessionNativeInterface.ARFaceAnchorUpdatedEvent += FaceUpdated;
		UnityARSessionNativeInterface.ARFaceAnchorRemovedEvent += FaceRemoved;
	}

	void Update () { // Called once per frame. Used e.g. for input.
	//	transform.position -= transform.forward * Time.deltaTime * (float)(7);
		var rotateAmount = rotateSpeed * Time.deltaTime;
//		var direction;
//		moveDirection = Vector3.zero;
//		moveDirection += Vector3.back/3;
		/*
		if (Input.GetKey (moveForward)) {
			moveDirection += Vector3.forward;
		}
		if (Input.GetKey (moveBack)) {
			moveDirection += Vector3.back;
		}
		if (Input.GetKey (moveLeft)) {
			moveDirection += Vector3.left;
		}
		if (Input.GetKey (moveRight)) {
			moveDirection += Vector3.right;
		}
		*/

		if (Input.GetKey (turnLeft)) {
			transform.Rotate(0, -rotateAmount, 0);
		}
		if (Input.GetKey (turnRight)) {
			transform.Rotate(0, rotateAmount, 0);
		}
		int brow = (int)(currentBlendShapes ["browInnerUp"]*5);
		transform.position -= transform.forward * Time.deltaTime * (float)(5-brow);
		theCamera.fieldOfView = 75.0f-currentBlendShapes ["browInnerUp"]*30;
		//theCamera.transform.position -= transform.forward * Time.deltaTime * (float)(5-brow);

		if (shapeEnabled) {
			
			int mouth_right = (int)(currentBlendShapes ["mouthRight"]*10);
			int mouth_left = (int)(currentBlendShapes ["mouthLeft"]*10);

			transform.Rotate(0, -mouth_right/3, 0);
			transform.Rotate(0, mouth_left/3, 0);

		}

	}

	void FixedUpdate () { // Called once per fixed frame. Used e.g. for physics. Modify in Edit » Project Settings » Time.
		//Move (moveDirection);
//		Rotate (rotateSpeed, direction)
	}

	void Move (Vector3 direction) {
		GetComponent <Rigidbody> ().velocity = direction * moveSpeed;
	}

/*
	void Rotate () {
		GetComponent <Rigidbody> ().MoveRotation = direction * moveSpeed;
	}
*/	


	void FaceAdded (ARFaceAnchor anchorData)
	{
		shapeEnabled = true;
		currentBlendShapes = anchorData.blendShapes;
	}

	void FaceUpdated (ARFaceAnchor anchorData)
	{
		currentBlendShapes = anchorData.blendShapes;
	}

	void FaceRemoved (ARFaceAnchor anchorData)
	{
		shapeEnabled = false;
	}


}