﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.XR.iOS;

public class Spawner : MonoBehaviour {

	public GameObject[] enemies;
	public Vector3 spawnValues;
	public float spawnWait;
	public float spawnMostWait;
	public float spawnLeastWait;
	public int startWait;
	public bool stop;
	public TextMesh text;
	int randEnemy;


	public int amountSpawned;

	bool shapeEnabled = false;
	Dictionary<string, float> currentBlendShapes;
	int timesBlinked;
	bool wereEyesClosed;
	float blinktime;

	float spawntime;

	// Use this for initialization
	void Start () {
		//StartCoroutine (waitSpawner ());
		UnityARSessionNativeInterface.ARFaceAnchorAddedEvent += FaceAdded;
		UnityARSessionNativeInterface.ARFaceAnchorUpdatedEvent += FaceUpdated;
		UnityARSessionNativeInterface.ARFaceAnchorRemovedEvent += FaceRemoved;
		timesBlinked = 0;
		wereEyesClosed = false;
		text.gameObject.SetActive (false);
		blinktime = Time.time;
		spawntime = Time.time + spawnWait;
		amountSpawned = 0;

	}
	
	// Update is called once per frame
	void Update () {
		spawnWait = Random.Range (spawnLeastWait, spawnMostWait);


		if (shapeEnabled) {
			
			int left_eye = (int)(currentBlendShapes ["eyeBlink_L"] * 10);
			int right_eye = (int)(currentBlendShapes ["eyeBlink_R"] * 10);

			if (!wereEyesClosed && left_eye > 6 && right_eye > 6) {
				timesBlinked++;
				wereEyesClosed = true;
				blinktime = Time.time+0.5f;
			} else if (left_eye < 7 && right_eye < 7){
				wereEyesClosed = false;
			}
		


			if(timesBlinked==5){
				timesBlinked=0;
				for (int i = 0; i < 5; i++) {
					Spawnthem ();
				}
			
			}


		}
		if (Time.time > spawntime) {
			spawntime = Time.time + spawnWait;
			Spawnthem ();

		}


		if (Time.time < blinktime) {

			text.gameObject.SetActive (true);

		} else {
			text.gameObject.SetActive (false);
		}
	}

	void Spawnthem (){

		amountSpawned++;

		randEnemy = Random.Range (0, 3);

		Vector3 spawnPosition = new Vector3 (Random.Range (-spawnValues.x, spawnValues.x), 0.1f, Random.Range (-spawnValues.z, spawnValues.z));

		Instantiate (enemies [randEnemy], spawnPosition + transform.TransformPoint (0, 0, 0), gameObject.transform.rotation);

	}


/**	IEnumerator waitSpawner () {
		yield return new WaitForSeconds (startWait);

		while (!stop) {
			randEnemy = Random.Range (0, 3);

			Vector3 spawnPosition = new Vector3 (Random.Range (-spawnValues.x, spawnValues.x), 0.1f, Random.Range (-spawnValues.z, spawnValues.z));

			Instantiate (enemies [randEnemy], spawnPosition + transform.TransformPoint (0, 0, 0), gameObject.transform.rotation);

			yield return new WaitForSeconds (spawnWait);
		}
	}*/

	void FaceAdded (ARFaceAnchor anchorData)
	{
		shapeEnabled = true;
		currentBlendShapes = anchorData.blendShapes;
	}

	void FaceUpdated (ARFaceAnchor anchorData)
	{
		currentBlendShapes = anchorData.blendShapes;
	}

	void FaceRemoved (ARFaceAnchor anchorData)
	{
		shapeEnabled = false;
	}

}
